jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
Andreas Gampe | 34a8a0f | 2016-07-20 21:09:29 -0700 | [diff] [blame^] | 40 | tmp_dir="${TMPDIR}/${test_dir}" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Vladimir Marko | f45c3f8 | 2015-12-15 16:36:24 +0000 | [diff] [blame] | 44 | export JAVAC="javac -g -source 1.7 -target 1.7 -Xlint:-options" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Nicolas Geoffray | 1c5b6da | 2016-03-16 10:55:57 +0000 | [diff] [blame] | 48 | export USE_JACK="true" |
Alex Light | b55f1ac | 2016-04-12 15:50:55 -0700 | [diff] [blame] | 49 | export SMALI_ARGS="--experimental" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 50 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 51 | # If dx was not set by the environment variable, assume it is in the path. |
| 52 | if [ -z "$DX" ]; then |
| 53 | export DX="dx" |
| 54 | fi |
| 55 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 56 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 57 | if [ -z "$JASMIN" ]; then |
| 58 | export JASMIN="jasmin" |
| 59 | fi |
| 60 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 61 | # If smali was not set by the environment variable, assume it is in the path. |
| 62 | if [ -z "$SMALI" ]; then |
| 63 | export SMALI="smali" |
| 64 | fi |
| 65 | |
| 66 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 67 | if [ -z "$DXMERGER" ]; then |
| 68 | export DXMERGER="dexmerger" |
| 69 | fi |
| 70 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 71 | # If jack was not set by the environment variable, assume it is in the path. |
| 72 | if [ -z "$JACK" ]; then |
| 73 | export JACK="jack" |
| 74 | fi |
| 75 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 76 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 77 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 78 | export ANDROID_BUILD_TOP=$oldwd |
| 79 | fi |
| 80 | |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 81 | # ANDROID_HOST_OUT is not set in a build environment. |
| 82 | if [ -z "$ANDROID_HOST_OUT" ]; then |
| 83 | export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86 |
| 84 | fi |
| 85 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 86 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 87 | if [ -z "$JACK_CLASSPATH" ]; then |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 88 | export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 89 | fi |
| 90 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 91 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 92 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 93 | info="info.txt" |
| 94 | build="build" |
| 95 | run="run" |
| 96 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 97 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 98 | output="output.txt" |
| 99 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 100 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 101 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 102 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 103 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 104 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 105 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 106 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 107 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 108 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 109 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 110 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 111 | dev_mode="no" |
| 112 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 113 | debug_mode="no" |
| 114 | relocate="yes" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 115 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 116 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 117 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 118 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 119 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 120 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 121 | basic_verify="false" |
| 122 | gc_verify="false" |
| 123 | gc_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 124 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 125 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 126 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 127 | have_dex2oat="yes" |
| 128 | have_patchoat="yes" |
| 129 | have_image="yes" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 130 | pic_image_suffix="" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 131 | multi_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 132 | android_root="/system" |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 133 | # By default we will use optimizing. |
| 134 | image_args="" |
| 135 | image_suffix="-optimizing" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 136 | |
| 137 | while true; do |
| 138 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 139 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 140 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 141 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 142 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 143 | elif [ "x$1" = "x--quiet" ]; then |
| 144 | quiet="yes" |
| 145 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 146 | elif [ "x$1" = "x--use-java-home" ]; then |
| 147 | if [ -n "${JAVA_HOME}" ]; then |
| 148 | export JAVA="${JAVA_HOME}/bin/java" |
| 149 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 150 | else |
| 151 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 152 | usage="yes" |
| 153 | fi |
| 154 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 155 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 156 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 157 | runtime="jvm" |
Alex Light | bc90d0f | 2016-05-09 16:21:09 -0700 | [diff] [blame] | 158 | image_args="" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 159 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 160 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 161 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 162 | run_args="${run_args} --jvm" |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 163 | build_args="${build_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 164 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 165 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 166 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 167 | testlib="arttest" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 168 | shift |
| 169 | elif [ "x$1" = "x--dalvik" ]; then |
| 170 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 171 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 172 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 173 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 174 | have_dex2oat="no" |
| 175 | shift |
| 176 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 177 | have_patchoat="no" |
| 178 | shift |
| 179 | elif [ "x$1" = "x--no-image" ]; then |
| 180 | have_image="no" |
| 181 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 182 | elif [ "x$1" = "x--pic-image" ]; then |
| 183 | pic_image_suffix="-pic" |
| 184 | shift |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 185 | elif [ "x$1" = "x--multi-image" ]; then |
| 186 | multi_image_suffix="-multi" |
| 187 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 188 | elif [ "x$1" = "x--pic-test" ]; then |
| 189 | run_args="${run_args} --pic-test" |
| 190 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 191 | elif [ "x$1" = "x--relocate" ]; then |
| 192 | relocate="yes" |
| 193 | shift |
| 194 | elif [ "x$1" = "x--no-relocate" ]; then |
| 195 | relocate="no" |
| 196 | shift |
| 197 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 198 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 199 | prebuild_mode="yes" |
| 200 | shift; |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 201 | elif [ "x$1" = "x--strip-dex" ]; then |
| 202 | run_args="${run_args} --strip-dex" |
| 203 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 204 | elif [ "x$1" = "x--debuggable" ]; then |
| 205 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 206 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 207 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 208 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 209 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 210 | prebuild_mode="no" |
| 211 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 212 | elif [ "x$1" = "x--gcverify" ]; then |
| 213 | basic_verify="true" |
| 214 | gc_verify="true" |
| 215 | shift |
| 216 | elif [ "x$1" = "x--gcstress" ]; then |
| 217 | basic_verify="true" |
| 218 | gc_stress="true" |
| 219 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 220 | elif [ "x$1" = "x--image" ]; then |
| 221 | shift |
| 222 | image="$1" |
| 223 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 224 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 225 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 226 | shift |
| 227 | option="$1" |
| 228 | run_args="${run_args} -Xcompiler-option $option" |
| 229 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 230 | elif [ "x$1" = "x--runtime-option" ]; then |
| 231 | shift |
| 232 | option="$1" |
| 233 | run_args="${run_args} --runtime-option $option" |
| 234 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 235 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 236 | shift |
| 237 | gdb_arg="$1" |
| 238 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 239 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 240 | elif [ "x$1" = "x--debug" ]; then |
| 241 | run_args="${run_args} --debug" |
| 242 | shift |
| 243 | elif [ "x$1" = "x--gdb" ]; then |
| 244 | run_args="${run_args} --gdb" |
| 245 | dev_mode="yes" |
| 246 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 247 | elif [ "x$1" = "x--strace" ]; then |
| 248 | strace="yes" |
Mathieu Chartier | 2576be2 | 2016-05-24 10:24:53 -0700 | [diff] [blame] | 249 | run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 250 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 251 | elif [ "x$1" = "x--zygote" ]; then |
| 252 | run_args="${run_args} --zygote" |
| 253 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 254 | elif [ "x$1" = "x--interpreter" ]; then |
Nicolas Geoffray | 4650c93 | 2016-05-10 09:13:13 +0000 | [diff] [blame] | 255 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 256 | image_suffix="-interpreter" |
| 257 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 258 | elif [ "x$1" = "x--jit" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 259 | image_args="--jit" |
Andreas Gampe | 8a159fd | 2015-09-21 15:14:38 -0700 | [diff] [blame] | 260 | image_suffix="-jit" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 261 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 262 | elif [ "x$1" = "x--optimizing" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 263 | image_args="-Xcompiler-option --compiler-backend=Optimizing" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 264 | image_suffix="-optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 265 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 266 | elif [ "x$1" = "x--no-verify" ]; then |
Richard Uhler | f4b3487 | 2016-04-13 11:03:46 -0700 | [diff] [blame] | 267 | run_args="${run_args} --no-verify" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 268 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 269 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 270 | image_args="--verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 271 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 272 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 273 | elif [ "x$1" = "x--no-optimize" ]; then |
| 274 | run_args="${run_args} --no-optimize" |
| 275 | shift |
| 276 | elif [ "x$1" = "x--no-precise" ]; then |
| 277 | run_args="${run_args} --no-precise" |
| 278 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 279 | elif [ "x$1" = "x--invoke-with" ]; then |
| 280 | shift |
| 281 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 282 | if [ "x$what" = "x" ]; then |
| 283 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 284 | usage="yes" |
| 285 | break |
| 286 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 287 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 288 | shift |
| 289 | elif [ "x$1" = "x--dev" ]; then |
| 290 | run_args="${run_args} --dev" |
| 291 | dev_mode="yes" |
| 292 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 293 | elif [ "x$1" = "x--build-only" ]; then |
| 294 | build_only="yes" |
| 295 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 296 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 297 | USE_JACK="false" |
| 298 | shift |
| 299 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 300 | USE_JACK="true" |
| 301 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 302 | elif [ "x$1" = "x--output-path" ]; then |
| 303 | shift |
| 304 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 305 | if [ "x$tmp_dir" = "x" ]; then |
| 306 | echo "$0 missing argument to --output-path" 1>&2 |
| 307 | usage="yes" |
| 308 | break |
| 309 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 310 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 311 | elif [ "x$1" = "x--android-root" ]; then |
| 312 | shift |
| 313 | if [ "x$1" = "x" ]; then |
| 314 | echo "$0 missing argument to --android-root" 1>&2 |
| 315 | usage="yes" |
| 316 | break |
| 317 | fi |
| 318 | android_root="$1" |
| 319 | run_args="${run_args} --android-root $1" |
| 320 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 321 | elif [ "x$1" = "x--update" ]; then |
| 322 | update_mode="yes" |
| 323 | shift |
| 324 | elif [ "x$1" = "x--help" ]; then |
| 325 | usage="yes" |
| 326 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 327 | elif [ "x$1" = "x--64" ]; then |
| 328 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 329 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 330 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 331 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 332 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 333 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 334 | elif [ "x$1" = "x--stream" ]; then |
| 335 | trace_stream="true" |
| 336 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 337 | elif [ "x$1" = "x--always-clean" ]; then |
| 338 | always_clean="yes" |
| 339 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 340 | elif [ "x$1" = "x--never-clean" ]; then |
| 341 | never_clean="yes" |
| 342 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 343 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 344 | run_args="${run_args} --dex2oat-swap" |
| 345 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 346 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 347 | shift |
| 348 | run_args="${run_args} --instruction-set-features $1" |
| 349 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 350 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 351 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 352 | usage="yes" |
| 353 | break |
| 354 | else |
| 355 | break |
| 356 | fi |
| 357 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 358 | |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 359 | run_args="${run_args} ${image_args}" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 360 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 361 | # output (fd 2). |
| 362 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 363 | exec {real_stderr}>&2 |
| 364 | else |
| 365 | # In bash before version 4.1 we need to do a manual search for free file |
| 366 | # descriptors. |
| 367 | FD=3 |
| 368 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 369 | real_stderr=$FD |
| 370 | eval "exec ${real_stderr}>&2" |
| 371 | fi |
| 372 | if [ "$quiet" = "yes" ]; then |
| 373 | # Force the default standard output and error to go to /dev/null so we will |
| 374 | # not print them. |
| 375 | exec 1>/dev/null |
| 376 | exec 2>/dev/null |
| 377 | fi |
| 378 | |
| 379 | function err_echo() { |
| 380 | echo "$@" 1>&${real_stderr} |
| 381 | } |
| 382 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 383 | # tmp_dir may be relative, resolve. |
| 384 | # |
| 385 | # Cannot use realpath, as it does not exist on Mac. |
| 386 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 387 | # Cannot use readlink -m, as it does not exist on Mac. |
| 388 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 389 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 390 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 391 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 392 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 393 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 394 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 395 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 396 | fi |
| 397 | if [ "$gc_verify" = "true" ]; then |
| 398 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 399 | fi |
| 400 | if [ "$gc_stress" = "true" ]; then |
Alex Light | 97acf19 | 2016-03-17 09:59:38 -0700 | [diff] [blame] | 401 | run_args="${run_args} --gc-stress --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 402 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 403 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 404 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 405 | if [ "$trace_stream" = "true" ]; then |
| 406 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 407 | # the ability to analyze the file and just write to /dev/null. |
| 408 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 409 | # Enable streaming mode. |
| 410 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 411 | else |
| 412 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 413 | fi |
| 414 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 415 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 416 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 417 | fi |
| 418 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 419 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 420 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 421 | function guess_target_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 422 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 423 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 424 | if [ "x${suffix64}" = "x64" ]; then |
| 425 | target_arch_name=${grep64bit} |
| 426 | else |
| 427 | target_arch_name=${grep32bit} |
| 428 | fi |
| 429 | } |
| 430 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 431 | function guess_host_arch_name() { |
| 432 | if [ "x${suffix64}" = "x64" ]; then |
| 433 | host_arch_name="x86_64" |
| 434 | else |
| 435 | host_arch_name="x86" |
| 436 | fi |
| 437 | } |
| 438 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 439 | if [ "$target_mode" = "no" ]; then |
| 440 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 441 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 442 | err_echo "--prebuild with --jvm is unsupported" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 443 | exit 1; |
| 444 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 445 | fi |
| 446 | fi |
| 447 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 448 | if [ "$have_patchoat" = "no" ]; then |
| 449 | run_args="${run_args} --no-patchoat" |
| 450 | fi |
| 451 | |
| 452 | if [ "$have_dex2oat" = "no" ]; then |
| 453 | run_args="${run_args} --no-dex2oat" |
| 454 | fi |
| 455 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 456 | if [ ! "$runtime" = "jvm" ]; then |
| 457 | run_args="${run_args} --lib $lib" |
| 458 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 459 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 460 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 461 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 462 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Andreas Gampe | 50be66f | 2015-12-28 14:31:06 -0800 | [diff] [blame] | 463 | bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 464 | run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 465 | else |
| 466 | true # defaults to using target BOOTCLASSPATH |
| 467 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 468 | elif [ "$runtime" = "art" ]; then |
| 469 | if [ "$target_mode" = "no" ]; then |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 470 | guess_host_arch_name |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 471 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 472 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 473 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 474 | guess_target_arch_name |
Dimitry Ivanov | 90d48f2 | 2016-05-05 17:24:28 -0700 | [diff] [blame] | 475 | run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}:/system/lib${suffix64}" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 476 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 477 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 478 | if [ "$relocate" = "yes" ]; then |
| 479 | run_args="${run_args} --relocate" |
| 480 | else |
| 481 | run_args="${run_args} --no-relocate" |
| 482 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 483 | elif [ "$runtime" = "jvm" ]; then |
| 484 | # TODO: Detect whether the host is 32-bit or 64-bit. |
| 485 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 486 | fi |
| 487 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 488 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 489 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 490 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 491 | exit 1 |
| 492 | fi |
| 493 | if [ "$target_mode" = "no" ]; then |
| 494 | framework="${ANDROID_HOST_OUT}/framework" |
| 495 | bpath_suffix="-hostdex" |
| 496 | else |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 497 | framework="${android_root}/framework" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 498 | bpath_suffix="" |
| 499 | fi |
| 500 | # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will |
| 501 | # fail since these jar files will be stripped. |
| 502 | bpath="${framework}/core-libart${bpath_suffix}.jar" |
Narayan Kamath | d50687e | 2015-11-17 12:37:27 +0000 | [diff] [blame] | 503 | bpath="${bpath}:${framework}/core-oj${bpath_suffix}.jar" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 504 | bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar" |
| 505 | bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 506 | bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar" |
| 507 | # Pass down the bootclasspath |
| 508 | run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 509 | run_args="${run_args} --no-image" |
| 510 | fi |
| 511 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 512 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 513 | err_echo "--dev and --update are mutually exclusive" |
| 514 | usage="yes" |
| 515 | fi |
| 516 | |
| 517 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 518 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 519 | usage="yes" |
| 520 | fi |
| 521 | |
| 522 | if [ "$usage" = "no" ]; then |
| 523 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 524 | test_dir=`basename "$oldwd"` |
| 525 | else |
| 526 | test_dir="$1" |
| 527 | fi |
| 528 | |
| 529 | if [ '!' -d "$test_dir" ]; then |
| 530 | td2=`echo ${test_dir}-*` |
| 531 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 532 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 533 | usage="yes" |
| 534 | fi |
| 535 | test_dir="$td2" |
| 536 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 537 | # Shift to get rid of the test name argument. The rest of the arguments |
| 538 | # will get passed to the test run. |
| 539 | shift |
| 540 | fi |
| 541 | |
| 542 | if [ "$usage" = "yes" ]; then |
| 543 | prog=`basename $prog` |
| 544 | ( |
| 545 | echo "usage:" |
| 546 | echo " $prog --help Print this message." |
| 547 | echo " $prog [options] [test-name] Run test normally." |
| 548 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 549 | "(dumps to stdout)." |
| 550 | echo " $prog --update [options] [test-name] Update mode" \ |
| 551 | "(replaces expected.txt)." |
| 552 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 553 | "current directory." |
| 554 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 555 | echo " -O Run non-debug rather than debug build (off by default)." |
| 556 | echo " -Xcompiler-option Pass an option to the compiler." |
| 557 | echo " --runtime-option Pass an option to the runtime." |
| 558 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 559 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 560 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 561 | echo " --gdb-arg Pass an option to gdb." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 562 | echo " --build-only Build test files only (off by default)." |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 563 | echo " --build-with-javac-dx Build test files with javac and dx (on by default)." |
| 564 | echo " --build-with-jack Build test files with jack and jill (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 565 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 566 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 567 | echo " --optimizing Enable optimizing compiler (default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 568 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 569 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 570 | echo " Verification is enabled if neither --no-verify" |
| 571 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 572 | echo " --no-optimize Turn off optimization (on by default)." |
| 573 | echo " --no-precise Turn off precise GC (on by default)." |
| 574 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 575 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 576 | echo " other runtime options are ignored." |
| 577 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 578 | echo " --no-patchoat Run as though patchoat was failing." |
| 579 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 580 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 581 | echo " the test." |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 582 | echo " --strip-dex Strip the dex files before starting test." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 583 | echo " --relocate Force the use of relocating in the test, making" |
| 584 | echo " the image and oat files be relocated to a random" |
| 585 | echo " address before running. (default)" |
| 586 | echo " --no-relocate Force the use of no relocating in the test" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 587 | echo " --image Run the test using a precompiled boot image. (default)" |
| 588 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 589 | echo " --host Use the host-mode virtual machine." |
| 590 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 591 | echo " --dalvik Use Dalvik (off by default)." |
| 592 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 593 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 594 | echo " to find the java compiler and runtime" |
| 595 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 596 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 597 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 598 | echo " --64 Run the test in 64-bit mode" |
| 599 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 600 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 601 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 602 | echo " --gcstress Run with gc stress testing" |
| 603 | echo " --gcverify Run with gc verification" |
| 604 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 605 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 606 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 607 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 608 | echo " --instruction-set-features [string]" |
| 609 | echo " Set instruction-set-features for compilation." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 610 | echo " --pic-image Use an image compiled with position independent code for the" |
| 611 | echo " boot class path." |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 612 | echo " --multi-image Use a set of images compiled with dex2oat multi-image for" |
| 613 | echo " the boot class path." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 614 | echo " --pic-test Compile the test code position independent." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 615 | echo " --quiet Don't print anything except failure messages" |
| 616 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 617 | exit 1 |
| 618 | fi |
| 619 | |
| 620 | cd "$test_dir" |
| 621 | test_dir=`pwd` |
| 622 | |
| 623 | td_info="${test_dir}/${info}" |
| 624 | td_expected="${test_dir}/${expected}" |
| 625 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 626 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 627 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 628 | exit 1 |
| 629 | fi |
| 630 | |
| 631 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 632 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 633 | exit 1 |
| 634 | fi |
| 635 | |
| 636 | # copy the test to a temp dir and run it |
| 637 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 638 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 639 | |
| 640 | rm -rf "$tmp_dir" |
| 641 | cp -Rp "$test_dir" "$tmp_dir" |
| 642 | cd "$tmp_dir" |
| 643 | |
| 644 | if [ '!' -r "$build" ]; then |
| 645 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 646 | else |
| 647 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 648 | fi |
| 649 | |
| 650 | if [ '!' -r "$run" ]; then |
| 651 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 652 | else |
| 653 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 654 | fi |
| 655 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 656 | if [ '!' -r "$check_cmd" ]; then |
| 657 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 658 | else |
| 659 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 660 | fi |
| 661 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 662 | chmod 755 "$build" |
| 663 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 664 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 665 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 666 | export TEST_NAME=`basename ${test_dir}` |
| 667 | |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 668 | # arch_supports_read_barrier ARCH |
| 669 | # ------------------------------- |
| 670 | # Return whether the Optimizing compiler has read barrier support for ARCH. |
| 671 | function arch_supports_read_barrier() { |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 672 | # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 673 | # moment. |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 674 | [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ] |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 675 | } |
| 676 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 677 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 678 | # Checker when compiled with Optimizing on host. |
| 679 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
David Brazdil | f02c3cf | 2016-02-29 09:14:51 +0000 | [diff] [blame] | 680 | if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" -a "$USE_JACK" = "true" ]; then |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 681 | # Optimizing has read barrier support for certain architectures |
| 682 | # only. On other architectures, compiling is disabled when read |
| 683 | # barriers are enabled, meaning that we do not produce a CFG file |
| 684 | # as a side-effect of compilation, thus the Checker assertions |
| 685 | # cannot be checked. Disable Checker for those cases. |
| 686 | # |
| 687 | # TODO: Enable Checker when read barrier support is added to more |
| 688 | # architectures (b/12687968). |
| 689 | if [ "x$ART_USE_READ_BARRIER" = xtrue ] \ |
| 690 | && (([ "x$host_mode" = "xyes" ] \ |
| 691 | && ! arch_supports_read_barrier "$host_arch_name") \ |
| 692 | || ([ "x$target_mode" = "xyes" ] \ |
| 693 | && ! arch_supports_read_barrier "$target_arch_name")); then |
| 694 | run_checker="no" |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 695 | # In no-prebuild mode, the compiler is only invoked if both dex2oat and |
| 696 | # patchoat are available. Disable Checker otherwise (b/22552692). |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 697 | elif [ "$prebuild_mode" = "yes" ] \ |
| 698 | || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 699 | run_checker="yes" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 700 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 701 | if [ "$target_mode" = "no" ]; then |
| 702 | cfg_output_dir="$tmp_dir" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 703 | checker_args="--arch=${host_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 704 | else |
| 705 | cfg_output_dir="$DEX_LOCATION" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 706 | checker_args="--arch=${target_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 707 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 708 | |
| 709 | if [ "$debuggable" = "yes" ]; then |
| 710 | checker_args="$checker_args --debuggable" |
| 711 | fi |
| 712 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 713 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 714 | -Xcompiler-option -j1" |
| 715 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 716 | fi |
| 717 | fi |
| 718 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 719 | if [ "$runtime" != "jvm" ]; then |
| 720 | run_args="${run_args} --testlib ${testlib}" |
| 721 | fi |
| 722 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 723 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 724 | build_file_size_limit=2048 |
| 725 | run_file_size_limit=2048 |
Alex Light | 4694e82 | 2016-01-22 10:09:40 -0800 | [diff] [blame] | 726 | |
| 727 | # Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with |
| 728 | # large amounts of expected output or large generated files. |
| 729 | if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 730 | build_file_size_limit=5120 |
| 731 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 732 | fi |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 733 | if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then |
| 734 | # We will need to `adb pull` the .cfg output from the target onto the host to |
| 735 | # run checker on it. This file can be big. |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 736 | build_file_size_limit=24576 |
| 737 | run_file_size_limit=24576 |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 738 | fi |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 739 | if [ ${USE_JACK} = "false" ]; then |
| 740 | # Set ulimit if we build with dx only, Jack can generate big temp files. |
| 741 | if ! ulimit -S "$build_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 742 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 743 | fi |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 744 | fi |
| 745 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 746 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 747 | good_build="yes" |
| 748 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 749 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 750 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 751 | build_exit="$?" |
| 752 | echo "build exit status: $build_exit" 1>&2 |
| 753 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 754 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 755 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 756 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 757 | echo "${test_dir}: running..." 1>&2 |
| 758 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 759 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 760 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 761 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 762 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 763 | if [ "$target_mode" = "yes" ]; then |
| 764 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 765 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 766 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 767 | checker_exit="$?" |
| 768 | if [ "$checker_exit" = "0" ]; then |
| 769 | good="yes" |
| 770 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 771 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 772 | else |
| 773 | good="yes" |
| 774 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 775 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 776 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 777 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 778 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 779 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 780 | build_exit="$?" |
| 781 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 782 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 783 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 784 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 785 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 786 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 787 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 788 | if [ "$target_mode" = "yes" ]; then |
| 789 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 790 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 791 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 792 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 793 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 794 | good="yes" |
| 795 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 796 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 797 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 798 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 799 | elif [ "$build_only" = "yes" ]; then |
| 800 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 801 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 802 | build_exit="$?" |
| 803 | if [ "$build_exit" '!=' '0' ]; then |
| 804 | cp "$build_output" "$output" |
| 805 | echo "build exit status: $build_exit" >>"$output" |
| 806 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 807 | if [ "$?" '!=' "0" ]; then |
| 808 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 809 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 810 | fi |
| 811 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 812 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 813 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 814 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 815 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 816 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 817 | build_exit="$?" |
| 818 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 819 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 820 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 821 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 822 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 823 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 824 | run_exit="$?" |
| 825 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 826 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 827 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 828 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 829 | if [ "$target_mode" = "yes" ]; then |
| 830 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 831 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 832 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 833 | checker_exit="$?" |
| 834 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 835 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 836 | good_run="no" |
| 837 | else |
| 838 | good_run="yes" |
| 839 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 840 | else |
| 841 | good_run="yes" |
| 842 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 843 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 844 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 845 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 846 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 847 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 848 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 849 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 850 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 851 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 852 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 853 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 854 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 855 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 856 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 857 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 858 | # output == expected |
| 859 | good="yes" |
| 860 | echo "${test_dir}: succeeded!" 1>&2 |
| 861 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 862 | fi |
| 863 | fi |
| 864 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 865 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 866 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 867 | echo "${test_dir}: FAILED!" |
| 868 | echo ' ' |
| 869 | echo '#################### info' |
| 870 | cat "${td_info}" | sed 's/^/# /g' |
| 871 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 872 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 873 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 874 | if [ "$strace" = "yes" ]; then |
| 875 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 876 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 877 | echo '####################' |
| 878 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 879 | echo ' ' |
| 880 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 881 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 882 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 883 | |
| 884 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 885 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 886 | cd "$oldwd" |
| 887 | rm -rf "$tmp_dir" |
| 888 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 889 | adb shell rm -rf $DEX_LOCATION |
| 890 | fi |
| 891 | if [ "$good" = "yes" ]; then |
| 892 | exit 0 |
| 893 | fi |
| 894 | fi |
| 895 | |
| 896 | |
| 897 | ( |
| 898 | if [ "$always_clean" = "yes" ]; then |
| 899 | echo "${TEST_NAME} files deleted from host " |
| 900 | if [ "$target_mode" == "yes" ]; then |
| 901 | echo "and from target" |
| 902 | fi |
| 903 | else |
| 904 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 905 | if [ "$target_mode" == "yes" ]; then |
| 906 | echo "and in ${DEX_LOCATION} on target" |
| 907 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 908 | fi |
| 909 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 910 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 911 | |
Alex Light | 6a870fa | 2016-05-31 16:36:19 -0700 | [diff] [blame] | 912 | if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then |
| 913 | exit 0 |
| 914 | else |
| 915 | exit 1 |
| 916 | fi |